// ListenSocket.cpp : implementation file
//

#include "stdafx.h"
#include "TestServer.h"
#include "ListenSocket.h"
#include "ClientSocket.h"
#include "TestServerDlg.h"


// CListenSocket

CListenSocket::CListenSocket()
{
	// Default value
	m_nMax = 100;
}

CListenSocket::~CListenSocket()
{	
}


// CListenSocket member functions

void CListenSocket::OnAccept(int nErrorCode)
{
	// TODO: Add your specialized code here and/or call the base class
	//----------------------------------------------------------------------------
	// Exceed Client
	if(m_nMax <= (UINT)m_ptrClientList.GetCount())
	{
		CClientSocket * pClient = new CClientSocket;
		if(Accept(*pClient))
		{
			// If you want to send message you can send here.
			pClient->ShutDown();
			pClient->Close();
		}

		delete pClient;

		CAsyncSocket::OnAccept(nErrorCode);
		return;
	}

	///----------------------------------------------------------------------------
	// Accept Client and Add List
	CClientSocket * pClient = new CClientSocket;
	if(Accept(*pClient))
	{
		CString strIP;
		UINT nPort;

		pClient->SetListenSocket(this);
		m_ptrClientList.AddTail(pClient);
		pClient->GetPeerName(strIP, nPort);

		CTestServerDlg * pMain = (CTestServerDlg*) AfxGetMainWnd();
		pMain->AddIP(strIP, nPort);
	}
	else
	{
		delete pClient;
		TRACE("Faile accept");
	}
	//----------------------------------------------------------------------------

	CAsyncSocket::OnAccept(nErrorCode);
}

void CListenSocket::CloseClientSocket(CSocket * pClient)
{
	//----------------------------------------------------------------------------
	// Find Client, Close Socket, Delete
	POSITION pos;
	pos = m_ptrClientList.Find(pClient);
	if(pos != NULL)
	{
		if(pClient != NULL)
		{
			CString strIP;
			UINT nPort;
			
			pClient->GetPeerName(strIP, nPort);
			CTestServerDlg * pMain = (CTestServerDlg*) AfxGetMainWnd();
			pMain->DeleteList(strIP, nPort);
			
			pClient->ShutDown();
			pClient->Close();
		}

		m_ptrClientList.RemoveAt(pos);
		delete pClient;
	}
	//----------------------------------------------------------------------------
}